      program crop
c
      implicit none
c
      integer i,j,k,nn1,mode,nx,ny,nz,ir,icx,icy
      integer xmin,xmax,ymin,ymax,zmin,zmax,icz
      integer nnx,nny,nnz,imode,ibox,iby,ibz
      parameter (nn1=5000)
      real imge(nn1,nn1),psize,out(nn1,nn1)
      character fname*200,cform,title*80
c
      write(*,*) ' CROP V1.3 - 05.03.2012'
      write(*,*) ' Distributed under the GNU',
     +           ' General Public License (GPL)'

      write(*,*)
c
      write(*,*) 'Input format [M,S,I]'
      read(*,*) cform
      write(*,*) cform
c
      write(*,*) 'Input image/volume to crop'
      read(*,'(a200)') fname
      write(*,'(3x,a200)') fname
c
      call iopen(fname,10,cform,mode,nx,ny,nz,'old',
     +           psize,title)
c
      write(*,*) 'Output cropped image/volume'
      read(*,'(a200)') fname
      write(*,'(3x,a200)') fname
c
      write(*,*) 'Mode (1=Min/max coord., 2=center box, 3=arb. box)'
      read(*,*) imode
      write(*,*) imode
c
      if (imode.eq.1) then
c
      if (nz.eq.1) then
        write(*,*) 'Xmin,Xmax,Ymin,Ymax'
        write(*,*) '(0,0 is origin)'
        read(*,*) xmin,xmax,ymin,ymax
        write(*,*) xmin,xmax,ymin,ymax
        zmin=0
        zmax=0
      else
        write(*,*) 'Xmin,Xmax,Ymin,Ymax,Zmin,Zmax'
        write(*,*) '(0,0,0 is origin)'
        read(*,*) xmin,xmax,ymin,ymax,zmin,zmax
        write(*,*) xmin,xmax,ymin,ymax,zmin,zmax
      endif
c
      elseif (imode.eq.2) then
c
      write(*,*) 'Box size'
      read(*,*) ibox
      write(*,*) ibox
      xmin=nx/2-ibox/2
      xmax=nx/2+ibox/2-1
      if (xmax-xmin+1.lt.ibox) xmax=xmax+1
      if (xmin.lt.0) xmin=0
      if (xmax.ge.nx) xmax=nx-1
      ymin=ny/2-ibox/2
      ymax=ny/2+ibox/2-1
      if (ymax-ymin+1.lt.ibox) ymax=ymax+1
      if (ymin.lt.0) ymin=0
      if (ymax.ge.ny) ymax=ny-1
      zmin=nz/2-ibox/2
      zmax=nz/2+ibox/2-1
      if (zmax-zmin+1.lt.ibox) zmax=zmax+1
      if (zmin.lt.0) zmin=0
      if (zmax.ge.nz) zmax=nz-1
c
      elseif (imode.eq.3) then
c
      write(*,*) 'Box size (x,y,z dimensions)'
      read(*,*) ibox,iby,ibz
      write(*,*) ibox,iby,ibz
      write(*,*) 'Box center (x,y,z coord.)'
      read(*,*) icx,icy,icz
      write(*,*) icx,icy,icz
      xmin=icx-ibox/2
      xmax=icx+ibox/2-1
      if (xmax-xmin+1.lt.ibox) xmax=xmax+1
      if (xmin.lt.0) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting x center to,',icx-xmin
        xmax=xmax-xmin
        xmin=0
      endif
      if (xmax.ge.nx) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting x center to,',icx-xmax+nx-1
        xmin=xmin-xmax+nx-1
        xmax=nx-1
      endif
      if (xmin.lt.0) xmin=0
      if (xmax.ge.nx) xmax=nx-1
      ymin=icy-iby/2
      ymax=icy+iby/2-1
      if (ymax-ymin+1.lt.iby) ymax=ymax+1
      if (ymin.lt.0) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting y center to,',icy-ymin
        ymax=ymax-ymin
        ymin=0
      endif
      if (ymax.ge.ny) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting y center to,',icy-ymax+ny-1
        ymin=ymin-ymax+ny-1
        ymax=ny-1
      endif
      if (ymin.lt.0) ymin=0
      if (ymax.ge.ny) ymax=ny-1
      zmin=icz-ibz/2
      zmax=icz+ibz/2-1
      if (zmax-zmin+1.lt.ibz) zmax=zmax+1
      if (zmin.lt.0) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting z center to,',icz-zmin
        zmax=zmax-zmin
        zmin=0
      endif
      if (zmax.ge.nz) then
        write(*,*) 'Box out of bounds!'
        write(*,*) 'Resetting z center to,',icz-zmax+nz-1
        zmin=zmin-zmax+nz-1
        zmax=nz-1
      endif
      if (zmin.lt.0) zmin=0
      if (zmax.ge.nz) zmax=nz-1
c
      else
c
      stop ' ERROR: Invalid option'
c
      endif
c
      write(*,*) 'Turn (1=0deg, 2=90deg, 3=180deg, 4=270deg)'
      read(*,*) ir
      write(*,*) ir
c
      if (xmin.gt.xmax) stop 'ERROR: Xmax smaller than Xmin'
      if (ymin.gt.ymax) stop 'ERROR: Ymax smaller than Ymin'
      if (zmin.gt.zmax) stop 'ERROR: Zmax smaller than Zmin'
c
      write(*,1100) xmin,xmax,ymin,ymax,zmin,zmax
1100  format(' Box boundaries = ',6I6)
c
      nnx=xmax-xmin+1
      nny=ymax-ymin+1
      nnz=zmax-zmin+1
      title='Cropped with CROP'
      if ((ir.eq.1).or.(ir.eq.3)) then
        call iopen(fname,11,cform,mode,nnx,nny,
     +             nnz,'new',psize,title)
      else
        call iopen(fname,11,cform,mode,nny,nnx,
     +             nnz,'new',psize,title)
      endif
c
      do 70 i=zmin+1,zmax+1
c
        do 10 j=ymin+1,ymax+1
          call iread(10,imge(1,j),j+ny*(i-1))
10      continue
c
        if (ir.eq.1) then
          do 50 j=ymin+1,ymax+1
            do 50 k=xmin+1,xmax+1
              out(k-xmin,j-ymin)=imge(k,j)
50        continue
        elseif (ir.eq.2) then
          do 20 j=ymin+1,ymax+1
            do 20 k=xmin+1,xmax+1
              out(ymax-j+2,k-xmin)=imge(k,j)
20        continue
        elseif (ir.eq.3) then
          do 30 j=ymin+1,ymax+1
            do 30 k=xmin+1,xmax+1
              out(xmax-k+2,ymax-j+2)=imge(k,j)
30        continue
        elseif (ir.eq.4) then
          do 40 j=ymin+1,ymax+1
            do 40 k=xmin+1,xmax+1
              out(j-ymin,xmax-k+2)=imge(k,j)
40        continue
        else
          stop '**** ERROR: Invalid option ****'
        endif
c
        do 60 j=1,nny
          call iwrite(11,out(1,j),j+nny*(i-zmin-1))
60      continue
c
70    continue
c
      call iclose(10)
      call iclose(11)
c
      end
